From b12fa84b08f566fdc804d6e70e0e9ccefdda7614 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Mon, 6 Feb 2012 15:44:34 -0600
Subject: [PATCH] Added generics (part 4).

This patch brings down the warnings from 3500 to 2981.

Ticket #2
---
 pki/base/ca/src/com/netscape/ca/CAService.java     |   20 ++++----
 .../ca/src/com/netscape/ca/CMSCRLExtensions.java   |    6 +-
 .../ca/src/com/netscape/ca/CRLIssuingPoint.java    |    3 +-
 .../src/com/netscape/ca/CertificateAuthority.java  |   17 +++---
 .../src/com/netscape/certsrv/acls/ACLEntry.java    |    2 +-
 .../certsrv/base/IConfigStoreEventListener.java    |    4 +-
 .../certsrv/dbs/certdb/ICertificateRepository.java |   17 +++---
 .../netscape/certsrv/dbs/crldb/ICRLRepository.java |   16 ++++--
 .../netscape/certsrv/dbs/keydb/IKeyRepository.java |    4 +-
 .../src/com/netscape/certsrv/ocsp/IDefStore.java   |    4 +-
 .../netscape/certsrv/publish/IPublishRuleSet.java  |    2 +-
 .../com/netscape/certsrv/request/IRequestList.java |    2 +-
 .../netscape/certsrv/security/IStorageKeyUnit.java |    2 +-
 .../com/netscape/cms/authentication/CMCAuth.java   |    3 +-
 .../cms/authentication/HashAuthentication.java     |   12 ++--
 .../netscape/cms/jobs/RenewalNotificationJob.java  |    1 -
 .../netscape/cms/listeners/PinRemovalListener.java |    5 --
 .../netscape/cms/listeners/RequestInQListener.java |    2 +-
 .../common/src/com/netscape/cms/ocsp/DefStore.java |   57 ++++++++++---------
 .../src/com/netscape/cms/ocsp/LDAPStore.java       |   21 ++++----
 .../cms/profile/common/ProfileContext.java         |    4 +-
 .../cms/profile/common/RAEnrollProfile.java        |    4 +-
 .../cms/profile/input/SubjectNameInput.java        |    4 +-
 .../com/netscape/cms/publish/publishers/Utils.java |    2 +-
 .../cms/servlet/admin/CMSAdminServlet.java         |    1 -
 .../cms/servlet/admin/JobsAdminServlet.java        |    2 +-
 .../cms/servlet/base/DisplayHtmlServlet.java       |    3 +-
 .../com/netscape/cms/servlet/base/GetStats.java    |    3 -
 .../netscape/cms/servlet/base/ProxyServlet.java    |   41 +++++++-------
 .../cms/servlet/cert/DisplayHashUserEnroll.java    |    3 -
 .../netscape/cms/servlet/cert/GetEnableStatus.java |    3 -
 .../netscape/cms/servlet/cert/ReasonToRevoke.java  |    4 +-
 .../cms/servlet/cert/RemoteAuthConfig.java         |    4 +-
 .../com/netscape/cms/servlet/cert/SrchCerts.java   |    1 -
 .../netscape/cms/servlet/common/CMSTemplate.java   |    2 -
 .../cms/servlet/csadmin/CheckIdentity.java         |    6 +--
 .../netscape/cms/servlet/csadmin/GetTokenInfo.java |    5 --
 .../cms/servlet/key/ConfirmRecoverBySerial.java    |    3 +-
 .../netscape/cms/servlet/key/ExamineRecovery.java  |    2 +-
 .../src/com/netscape/cms/servlet/key/GetPk12.java  |    3 +-
 .../netscape/cms/servlet/key/GrantRecovery.java    |    2 +-
 .../netscape/cms/servlet/key/KeyRecordParser.java  |    1 -
 .../netscape/cms/servlet/key/RecoverBySerial.java  |   10 ++--
 .../src/com/netscape/cms/servlet/key/SrchKey.java  |    5 +-
 .../cms/servlet/key/SrchKeyForRecovery.java        |    5 +-
 .../com/netscape/cms/servlet/ocsp/GetOCSPInfo.java |    3 -
 .../netscape/cms/servlet/ocsp/ListCAServlet.java   |    4 +-
 .../cms/servlet/processors/CMCProcessor.java       |    2 +-
 .../cms/servlet/processors/CRMFProcessor.java      |    1 -
 .../servlet/profile/ProfileSubmitCMCServlet.java   |    3 -
 .../cms/servlet/profile/ProfileSubmitServlet.java  |    3 +-
 .../src/com/netscape/cms/shares/OldJoinShares.java |   18 +++---
 .../src/com/netscape/cms/shares/OldShare.java      |   11 ++--
 .../ChallengePhraseAuthentication.java             |    3 -
 .../com/netscape/cmscore/base/PropConfigStore.java |   14 ++---
 .../com/netscape/cmscore/cert/CertDateCompare.java |    8 ++--
 .../src/com/netscape/cmscore/cert/CertUtils.java   |    1 -
 .../netscape/cmscore/cert/X500NameSubsystem.java   |    4 +-
 .../netscape/cmscore/connector/LocalConnector.java |    4 +-
 .../cmscore/dbs/CRLIssuingPointRecord.java         |   47 ++++++++++-------
 .../com/netscape/cmscore/dbs/CRLRepository.java    |   19 ++++---
 .../cmscore/dbs/CertificateRepository.java         |   24 ++++-----
 .../com/netscape/cmscore/dbs/KeyRecordList.java    |    8 ++--
 .../com/netscape/cmscore/dbs/KeyRepository.java    |   27 ++++++----
 .../netscape/cmscore/dbs/LdapFilterConverter.java  |    4 +-
 .../com/netscape/cmscore/dbs/PublicKeyMapper.java  |    6 +-
 .../netscape/cmscore/dbs/X509CertImplMapper.java   |    2 -
 .../netscape/cmscore/ldap/LdapPublishModule.java   |   11 +---
 .../netscape/cmscore/ldap/LdapRequestListener.java |    4 +-
 .../netscape/cmscore/ldapconn/LdapAuthInfo.java    |    4 +-
 .../netscape/cmscore/listeners/ListenerPlugin.java |    2 +-
 .../src/com/netscape/cmscore/logging/Logger.java   |    7 +--
 .../netscape/cmscore/request/ARequestQueue.java    |    1 -
 .../com/netscape/cmscore/request/RequestQueue.java |   10 ++--
 .../cmscore/request/RequestRepository.java         |    8 ++--
 .../netscape/cmscore/security/JssSubsystem.java    |    1 -
 .../com/netscape/cmscore/security/PWsdrCache.java  |   10 +---
 .../cmscore/selftests/SelfTestSubsystem.java       |    6 +-
 .../com/netscape/cmscore/util/StatsSubsystem.java  |   12 ++--
 .../netscape/cmscore/dbs/CertRecordListTest.java   |    7 ++-
 .../cmscore/dbs/DBSSessionDefaultStub.java         |    6 +-
 .../cmscore/dbs/DBVirtualListDefaultStub.java      |    6 +-
 .../src/com/netscape/cmstools/CMCResponse.java     |    2 -
 .../src/com/netscape/cmstools/PasswordCache.java   |    1 -
 .../src/com/netscape/cmstools/TestCRLSigning.java  |    5 +-
 .../src/com/netscape/kra/EnrollmentService.java    |    4 +-
 pki/base/kra/src/com/netscape/kra/KRAService.java  |    5 +-
 .../kra/src/com/netscape/kra/RecoveryService.java  |   12 ++--
 .../com/netscape/kra/TokenKeyRecoveryService.java  |    4 +-
 .../ocsp/src/com/netscape/ocsp/OCSPAuthority.java  |    7 +--
 .../src/com/netscape/pkisilent/ConfigureDRM.java   |   32 +----------
 .../src/com/netscape/pkisilent/ConfigureOCSP.java  |   30 +----------
 .../src/com/netscape/pkisilent/ConfigureRA.java    |   25 +--------
 .../com/netscape/pkisilent/common/ComCrypto.java   |    4 +-
 .../com/netscape/cmsutil/crypto/CryptoUtil.java    |    1 -
 .../netscape/cmsutil/http/JssSSLSocketFactory.java |    2 +-
 .../netscape/cmsutil/password/IPasswordReader.java |    2 +-
 .../netscape/cmsutil/password/IPasswordStore.java  |    2 +-
 .../cmsutil/password/PlainPasswordFile.java        |   10 +++-
 .../cmsutil/password/PlainPasswordReader.java      |   10 +++-
 .../util/src/com/netscape/cmsutil/util/Utils.java  |    2 +-
 .../util/src/netscape/security/pkcs/PKCS7.java     |    3 -
 .../util/src/netscape/security/pkcs/PKCS8Key.java  |    2 +-
 .../netscape/security/pkcs/PKCS9Attributes.java    |   13 ++---
 .../util/src/netscape/security/provider/CMS.java   |    2 +-
 .../netscape/security/provider/DSAKeyFactory.java  |   19 ++++---
 .../netscape/security/provider/DSAParameters.java  |    7 ++-
 .../netscape/security/util/ASN1CharStrConvMap.java |    1 -
 .../netscape/security/util/ByteArrayLexOrder.java  |    7 +--
 .../netscape/security/util/ByteArrayTagOrder.java  |    7 +--
 .../netscape/security/util/DerOutputStream.java    |    2 +-
 .../netscape/security/util/ObjectIdentifier.java   |    5 +-
 .../security/x509/FreshestCRLExtension.java        |    1 -
 .../security/x509/LdapV3DNStrConverter.java        |    4 +-
 pki/base/util/src/netscape/security/x509/RDN.java  |    1 -
 .../util/src/netscape/security/x509/X509Cert.java  |    1 -
 116 files changed, 373 insertions(+), 496 deletions(-)

diff --git a/pki/base/ca/src/com/netscape/ca/CAService.java b/pki/base/ca/src/com/netscape/ca/CAService.java
index d086ee551ae25b9f893c63d2160471e6ecf2e51e..d8faa8b348c052099639344819c4d96455a95fed 100644
--- a/pki/base/ca/src/com/netscape/ca/CAService.java
+++ b/pki/base/ca/src/com/netscape/ca/CAService.java
@@ -410,7 +410,7 @@ public class CAService implements ICAService, IService {
         }
 
         String type = request.getRequestType();
-        IServant servant = (IServant) mServants.get(type);
+        IServant servant = mServants.get(type);
 
         if (servant == null) {
             mCA.log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSCORE_CA_INVALID_REQUEST_TYPE", type));
@@ -923,7 +923,7 @@ public class CAService implements ICAService, IService {
                         Enumeration<String> n = oldMeta.getElements();
 
                         while (n.hasMoreElements()) {
-                            String name = (String) n.nextElement();
+                            String name = n.nextElement();
 
                             System.out.println("name " + name + " value " +
                                     oldMeta.get(name));
@@ -950,7 +950,7 @@ public class CAService implements ICAService, IService {
                     Enumeration<String> n = oldMeta.getElements();
 
                     while (n.hasMoreElements()) {
-                        String name = (String) n.nextElement();
+                        String name = n.nextElement();
 
                     }
                 }
@@ -1105,7 +1105,7 @@ public class CAService implements ICAService, IService {
                 Enumeration<ICRLIssuingPoint> eIPs = mCRLIssuingPoints.elements();
 
                 while (eIPs.hasMoreElements()) {
-                    ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
+                    ICRLIssuingPoint ip = eIPs.nextElement();
 
                     if (ip != null) {
                         boolean b = true;
@@ -1434,7 +1434,7 @@ class serviceRenewal implements IServant {
 
                     if (renewed != null) {
                         BigInteger serial = new BigInteger(renewed);
-                        X509CertImpl cert = (X509CertImpl)
+                        X509CertImpl cert =
                                 mCA.getCertificateRepository().getX509Certificate(serial);
 
                         if (cert == null) {
@@ -1898,7 +1898,7 @@ class serviceGetCRL implements IServant {
             throws EBaseException {
         try {
             ICRLIssuingPointRecord crlRec =
-                    (ICRLIssuingPointRecord) mCA.getCRLRepository().readCRLIssuingPointRecord(
+                    mCA.getCRLRepository().readCRLIssuingPointRecord(
                             ICertificateAuthority.PROP_MASTER_CRL);
             X509CRLImpl crl = new X509CRLImpl(crlRec.getCRL());
 
@@ -1936,7 +1936,7 @@ class serviceGetRevocationInfo implements IServant {
         Enumeration<String> enum1 = request.getExtDataKeys();
 
         while (enum1.hasMoreElements()) {
-            String name = (String) enum1.nextElement();
+            String name = enum1.nextElement();
 
             if (name.equals(IRequest.ISSUED_CERTS)) {
                 X509CertImpl certsToCheck[] =
@@ -1976,7 +1976,7 @@ class serviceGetCertificates implements IServant {
         Enumeration<String> enum1 = request.getExtDataKeys();
 
         while (enum1.hasMoreElements()) {
-            String name = (String) enum1.nextElement();
+            String name = enum1.nextElement();
 
             if (name.equals(IRequest.CERT_FILTER)) {
                 String filter = request.getExtDataInString(IRequest.CERT_FILTER);
@@ -2046,7 +2046,7 @@ class serviceCert4Crl implements IServant {
                 Enumeration<ICRLIssuingPoint> eIPs = hips.elements();
 
                 while (eIPs.hasMoreElements()) {
-                    ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
+                    ICRLIssuingPoint ip = eIPs.nextElement();
                     // form RevokedCertImpl
                     RevokedCertImpl rci =
                             new RevokedCertImpl(revokedCertRecs[i].getSerialNumber(),
@@ -2108,7 +2108,7 @@ class serviceUnCert4Crl implements IServant {
                 Enumeration<ICRLIssuingPoint> eIPs = hips.elements();
 
                 while (eIPs.hasMoreElements()) {
-                    ICRLIssuingPoint ip = (ICRLIssuingPoint) eIPs.nextElement();
+                    ICRLIssuingPoint ip = eIPs.nextElement();
 
                     if (ip != null) {
                         ip.addUnrevokedCert(oldSerialNo[i]);
diff --git a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
index 0d98b96319539c896f5b7d7f88950baef4c96a1d..8c59d42d80c4c38633ba0e8d246410b2c7fbfb3d 100644
--- a/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
+++ b/pki/base/ca/src/com/netscape/ca/CMSCRLExtensions.java
@@ -200,7 +200,7 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
         IConfigStore mFileConfig =
                 SubsystemRegistry.getInstance().get("MAIN").getConfigStore();
 
-        IConfigStore crlExtConfig = (IConfigStore) mFileConfig;
+        IConfigStore crlExtConfig = mFileConfig;
         StringTokenizer st = new StringTokenizer(mCRLExtConfig.getName(), ".");
 
         while (st.hasMoreTokens()) {
@@ -471,11 +471,11 @@ public class CMSCRLExtensions implements ICMSCRLExtensions {
                     if (cmsCRLExt != null) {
                         if (ext != null) {
                             if (isCRLExtensionCritical(extName) ^ ext.isCritical()) {
-                                ext = (Extension) cmsCRLExt.setCRLExtensionCriticality(
+                                ext = cmsCRLExt.setCRLExtensionCriticality(
                                             ext, isCRLExtensionCritical(extName));
                             }
                         } else {
-                            ext = (Extension) cmsCRLExt.getCRLExtension(mCRLExtConfig.getSubStore(extName),
+                            ext = cmsCRLExt.getCRLExtension(mCRLExtConfig.getSubStore(extName),
                                         mCRLIssuingPoint,
                                         isCRLExtensionCritical(extName));
                         }
diff --git a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
index 46ddb544d08c1fc52cd597e88a63128e026e169e..1c89a29c8694847ee03ecb1f2964ad11578f04ff 100644
--- a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
+++ b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
@@ -635,7 +635,6 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
         Vector<String> listedProfiles = new Vector<String>();
 
         StringTokenizer elements = new StringTokenizer(list, ",", true);
-        int t0 = -1;
         int n = 0;
         while (elements.hasMoreTokens()) {
             String element = elements.nextToken().trim();
@@ -3151,7 +3150,7 @@ class CertRecProcessor implements IElementProcessor {
             boolean includeCert = checkRevokedCertExtensions(crlExts);
 
             if (includeCert == true) {
-                mCRLCerts.put(serialNumber, (RevokedCertificate) newRevokedCert);
+                mCRLCerts.put(serialNumber, newRevokedCert);
                 if (serialNumber != null) {
                     CMS.debug("Putting certificate serial: 0x" + serialNumber.toString(16) + " into CRL hashtable");
                 }
diff --git a/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java b/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
index dab9c069db82eeb324e1fc6646faeed35b6f8dc1..df7de2c5eb6a9d2482c8e589b1ba967d9f48b651 100644
--- a/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
+++ b/pki/base/ca/src/com/netscape/ca/CertificateAuthority.java
@@ -93,7 +93,6 @@ import com.netscape.cmscore.dbs.CertRecord;
 import com.netscape.cmscore.dbs.CertificateRepository;
 import com.netscape.cmscore.dbs.DBSubsystem;
 import com.netscape.cmscore.dbs.ReplicaIDRepository;
-import com.netscape.cmscore.dbs.Repository;
 import com.netscape.cmscore.ldap.PublisherProcessor;
 import com.netscape.cmscore.listeners.ListenerPlugin;
 import com.netscape.cmscore.request.RequestSubsystem;
@@ -590,7 +589,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
     public String getStartSerial() {
         try {
             BigInteger serial =
-                    ((Repository) mCertRepot).getTheSerialNumber();
+                    mCertRepot.getTheSerialNumber();
 
             if (serial == null)
                 return "";
@@ -603,11 +602,11 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
     }
 
     public void setStartSerial(String serial) throws EBaseException {
-        ((Repository) mCertRepot).setTheSerialNumber(new BigInteger(serial));
+        mCertRepot.setTheSerialNumber(new BigInteger(serial));
     }
 
     public String getMaxSerial() {
-        String serial = ((Repository) mCertRepot).getMaxSerial();
+        String serial = mCertRepot.getMaxSerial();
 
         if (serial != null)
             return serial;
@@ -616,7 +615,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
     }
 
     public void setMaxSerial(String serial) throws EBaseException {
-        ((Repository) mCertRepot).setMaxSerial(serial);
+        mCertRepot.setMaxSerial(serial);
     }
 
     /**
@@ -658,7 +657,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
      * @return CRL issuing point
      */
     public ICRLIssuingPoint getCRLIssuingPoint(String id) {
-        return (CRLIssuingPoint) mCRLIssuePoints.get(id);
+        return mCRLIssuePoints.get(id);
     }
 
     /**
@@ -1491,7 +1490,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
                 Enumeration<String> names = implc.getSubStoreNames();
 
                 while (names.hasMoreElements()) {
-                    String id = (String) names.nextElement();
+                    String id = names.nextElement();
 
                     if (Debug.ON)
                         Debug.trace("registering listener impl: " + id);
@@ -1698,7 +1697,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
         // a Master/full crl must exist.
 
         while (issuePointIdEnum.hasMoreElements()) {
-            String issuePointId = (String) issuePointIdEnum.nextElement();
+            String issuePointId = issuePointIdEnum.nextElement();
 
             CMS.debug(
                     "initializing crl issue point " + issuePointId);
@@ -1923,7 +1922,7 @@ public class CertificateAuthority implements ICertificateAuthority, ICertAuthori
 
             DerOutputStream tmpChain = new DerOutputStream();
             DerOutputStream tmp1 = new DerOutputStream();
-            DerOutputStream outChain = new DerOutputStream();
+            //DerOutputStream outChain = new DerOutputStream();
             java.security.cert.X509Certificate chains[] =
                     mOCSPCertChain.getChain();
 
diff --git a/pki/base/common/src/com/netscape/certsrv/acls/ACLEntry.java b/pki/base/common/src/com/netscape/certsrv/acls/ACLEntry.java
index 448b851e77316fbed5adc6d2ac416408dd37c117..2c1b7c3eadd929418ddbe66222b8ef7ffdfda97b 100644
--- a/pki/base/common/src/com/netscape/certsrv/acls/ACLEntry.java
+++ b/pki/base/common/src/com/netscape/certsrv/acls/ACLEntry.java
@@ -233,7 +233,7 @@ public class ACLEntry implements IACLEntry, java.io.Serializable {
         Enumeration<String> e = permissions();
 
         for (; e.hasMoreElements();) {
-            String p = (String) e.nextElement();
+            String p = e.nextElement();
 
             entry += p;
             if (e.hasMoreElements())
diff --git a/pki/base/common/src/com/netscape/certsrv/base/IConfigStoreEventListener.java b/pki/base/common/src/com/netscape/certsrv/base/IConfigStoreEventListener.java
index 376b4e91a946b1cc9bf8153ede11d02bff199b15..06e7d522af0d4c6027c453cb68aab71faa8076a2 100644
--- a/pki/base/common/src/com/netscape/certsrv/base/IConfigStoreEventListener.java
+++ b/pki/base/common/src/com/netscape/certsrv/base/IConfigStoreEventListener.java
@@ -34,7 +34,7 @@ public interface IConfigStoreEventListener {
      * @exception EBaseException failed to validate
      */
     public void validateConfigParams(String action,
-            Hashtable params) throws EBaseException;
+            Hashtable<String, String> params) throws EBaseException;
 
     /**
      * Validates the config store parameters that changed
@@ -44,5 +44,5 @@ public interface IConfigStoreEventListener {
      * @exception EBaseException failed to validate
      */
     public void doConfigParams(String action,
-            Hashtable params) throws EBaseException;
+            Hashtable<String, String> params) throws EBaseException;
 }
diff --git a/pki/base/common/src/com/netscape/certsrv/dbs/certdb/ICertificateRepository.java b/pki/base/common/src/com/netscape/certsrv/dbs/certdb/ICertificateRepository.java
index 60f8673682d800e4808790e3c7130d1fa7fabf7b..2e9e00f60e290b24c378a253bf0b293afaaf5f4a 100644
--- a/pki/base/common/src/com/netscape/certsrv/dbs/certdb/ICertificateRepository.java
+++ b/pki/base/common/src/com/netscape/certsrv/dbs/certdb/ICertificateRepository.java
@@ -30,6 +30,7 @@ import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.MetaInfo;
 import com.netscape.certsrv.dbs.ModificationSet;
 import com.netscape.certsrv.dbs.repository.IRepository;
+import com.netscape.cmscore.dbs.CertificateRepository.RenewableCertificateCollection;
 
 /**
  * An interface represents a CMS certificate repository.
@@ -205,7 +206,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration searchCertificates(String filter, int maxSize)
+    public Enumeration<Object> searchCertificates(String filter, int maxSize)
             throws EBaseException;
 
     /**
@@ -218,7 +219,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration searchCertificates(String filter, int maxSize,
+    public Enumeration<ICertRecord> searchCertificates(String filter, int maxSize,
             int timeLimit) throws EBaseException;
 
     /**
@@ -308,7 +309,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of revoked certificates
      * @exception EBaseException failed to retrieve
      */
-    public Enumeration getRevokedCertificates(Date asOfDate)
+    public Enumeration<ICertRecord> getRevokedCertificates(Date asOfDate)
             throws EBaseException;
 
     /**
@@ -318,7 +319,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of revoked certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration getAllRevokedCertificates()
+    public Enumeration<ICertRecord> getAllRevokedCertificates()
             throws EBaseException;
 
     /**
@@ -327,7 +328,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of revoked certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration getAllRevokedNonExpiredCertificates()
+    public Enumeration<ICertRecord> getAllRevokedNonExpiredCertificates()
             throws EBaseException;
 
     /**
@@ -337,7 +338,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration findCertificates(String filter)
+    public Enumeration<X509CertImpl> findCertificates(String filter)
             throws EBaseException;
 
     /**
@@ -347,7 +348,7 @@ public interface ICertificateRepository extends IRepository {
      * @return a list of certificates
      * @exception EBaseException failed to search
      */
-    public Enumeration findCertRecords(String filter)
+    public Enumeration<ICertRecord> findCertRecords(String filter)
             throws EBaseException;
 
     /**
@@ -414,7 +415,7 @@ public interface ICertificateRepository extends IRepository {
      * @return certificates
      * @exception EBaseException failed to retrieve
      */
-    public Hashtable getRenewableCertificates(String renewalTime)
+    public Hashtable<String, RenewableCertificateCollection> getRenewableCertificates(String renewalTime)
             throws EBaseException;
 
     /**
diff --git a/pki/base/common/src/com/netscape/certsrv/dbs/crldb/ICRLRepository.java b/pki/base/common/src/com/netscape/certsrv/dbs/crldb/ICRLRepository.java
index 3fb40b26d413502a6b88580646bad4d387f7a93a..806a2cb19ef0dffdd4529de6ec989cb1981c1e48 100644
--- a/pki/base/common/src/com/netscape/certsrv/dbs/crldb/ICRLRepository.java
+++ b/pki/base/common/src/com/netscape/certsrv/dbs/crldb/ICRLRepository.java
@@ -22,6 +22,8 @@ import java.util.Date;
 import java.util.Hashtable;
 import java.util.Vector;
 
+import netscape.security.x509.RevokedCertificate;
+
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.dbs.ModificationSet;
 
@@ -109,7 +111,9 @@ public interface ICRLRepository {
      */
     public void updateCRLIssuingPointRecord(String id, byte[] newCRL,
             Date thisUpdate, Date nextUpdate, BigInteger crlNumber, Long crlSize,
-            Hashtable revokedCerts, Hashtable unrevokedCerts, Hashtable expiredCerts)
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException;
 
     /**
@@ -120,7 +124,7 @@ public interface ICRLRepository {
      * @param unrevokedCerts list of released from hold certificates
      * @exception EBaseException failed to update issuing point record
      */
-    public void updateRevokedCerts(String id, Hashtable revokedCerts, Hashtable unrevokedCerts)
+    public void updateRevokedCerts(String id, Hashtable<BigInteger, RevokedCertificate> revokedCerts, Hashtable<BigInteger, RevokedCertificate> unrevokedCerts)
             throws EBaseException;
 
     /**
@@ -130,7 +134,7 @@ public interface ICRLRepository {
      * @param expiredCerts list of expired certificates
      * @exception EBaseException failed to update issuing point record
      */
-    public void updateExpiredCerts(String id, Hashtable expiredCerts)
+    public void updateExpiredCerts(String id, Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException;
 
     /**
@@ -144,9 +148,9 @@ public interface ICRLRepository {
      * @exception EBaseException failed to update issuing point record
      */
     public void updateCRLCache(String id, Long crlSize,
-            Hashtable revokedCerts,
-            Hashtable unrevokedCerts,
-            Hashtable expiredCerts)
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException;
 
     /**
diff --git a/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRepository.java b/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRepository.java
index ca1e2c8aa742a4c3577ed76fbde4e40ddf79f8d5..627844286b31364f3e9cbd0298608081ab7a8ce5 100644
--- a/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRepository.java
+++ b/pki/base/common/src/com/netscape/certsrv/dbs/keydb/IKeyRepository.java
@@ -97,7 +97,7 @@ public interface IKeyRepository extends IRepository {
      * @return a list of private key records
      * @exception EBaseException failed to search keys
      */
-    public Enumeration searchKeys(String filter, int maxSize)
+    public Enumeration<IKeyRecord> searchKeys(String filter, int maxSize)
             throws EBaseException;
 
     /**
@@ -109,7 +109,7 @@ public interface IKeyRepository extends IRepository {
      * @return a list of private key records
      * @exception EBaseException failed to search keys
      */
-    public Enumeration searchKeys(String filter, int maxSize, int timeLimt)
+    public Enumeration<IKeyRecord> searchKeys(String filter, int maxSize, int timeLimt)
             throws EBaseException;
 
     /**
diff --git a/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java b/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
index 7123de303ddfff3095e0e129e733c459f4f12517..ee4c76a08d3a00db4fee89f773bdce42be9fb745 100644
--- a/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
+++ b/pki/base/common/src/com/netscape/certsrv/ocsp/IDefStore.java
@@ -110,7 +110,7 @@ public interface IDefStore extends IOCSPStore {
      * @return Enumeration a list of the CRL issuing points
      * @exception EBaseException occurs when no CRL issuing point exists
      */
-    public Enumeration<Object> searchAllCRLIssuingPointRecord(
+    public Enumeration<ICRLIssuingPointRecord> searchAllCRLIssuingPointRecord(
             int maxSize)
             throws EBaseException;
 
@@ -124,7 +124,7 @@ public interface IDefStore extends IOCSPStore {
      * @return Enumeration a list of the CRL issuing points
      * @exception EBaseException occurs when no CRL issuing point exists
      */
-    public Enumeration searchCRLIssuingPointRecord(String filter,
+    public Enumeration<ICRLIssuingPointRecord> searchCRLIssuingPointRecord(String filter,
             int maxSize)
             throws EBaseException;
 
diff --git a/pki/base/common/src/com/netscape/certsrv/publish/IPublishRuleSet.java b/pki/base/common/src/com/netscape/certsrv/publish/IPublishRuleSet.java
index c1af492b89521981c71d2dfef583feab24c78c2f..911d4e132cb29acf224bbce982cf29b14fd9fbab 100644
--- a/pki/base/common/src/com/netscape/certsrv/publish/IPublishRuleSet.java
+++ b/pki/base/common/src/com/netscape/certsrv/publish/IPublishRuleSet.java
@@ -103,7 +103,7 @@ public interface IPublishRuleSet {
      * 
      * @return An enumeration of publishing rules.
      */
-    Enumeration getRules();
+    Enumeration<ILdapRule> getRules();
 
     /**
      * Apply publishing rules on a request.
diff --git a/pki/base/common/src/com/netscape/certsrv/request/IRequestList.java b/pki/base/common/src/com/netscape/certsrv/request/IRequestList.java
index e207c0014c9a857ff338776a5506aa85be2e467e..5f265941ae81ec207f7d8d54968264f6f81d4879 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/IRequestList.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/IRequestList.java
@@ -27,7 +27,7 @@ import java.util.Enumeration;
  * @version $Revision$, $Date$
  */
 public interface IRequestList
-        extends Enumeration {
+        extends Enumeration<RequestId> {
 
     /**
      * Gets the next RequestId from this list. null is
diff --git a/pki/base/common/src/com/netscape/certsrv/security/IStorageKeyUnit.java b/pki/base/common/src/com/netscape/certsrv/security/IStorageKeyUnit.java
index 336bf57ad9c4c482513fe662a01efbc736fa8084..5f3b0ec487c1b84ac6d22ffc4eb985516c29cd05 100644
--- a/pki/base/common/src/com/netscape/certsrv/security/IStorageKeyUnit.java
+++ b/pki/base/common/src/com/netscape/certsrv/security/IStorageKeyUnit.java
@@ -59,7 +59,7 @@ public interface IStorageKeyUnit extends IEncryptionUnit {
      * 
      * @return a list of string-based agent identifiers
      */
-    public Enumeration getAgentIdentifiers();
+    public Enumeration<String> getAgentIdentifiers();
 
     /**
      * Changes agent password.
